commit ed47725094a2d67822445670b5adb6b1a8cd13de
Author: Christophe Lyon <christophe.lyon@linaro.org>
Date:   Fri Aug 8 14:55:07 2025

    aarch64: libgcc: Honor disable-werror [PR117600]
    
    In commit r15-4417-g71c7b446b98aa5, I made -werror mandatory when
    building libgcc for aarch64.
    
    While it achieved its goal (make us fix problems unnoticed so far),
    there has a been a lot of debate because it couldn't be disabled
    easily.
    
    This patch adds support for --enable-werror/--disable-werror in
    libgcc, defaulting to --enable-werror for aarch64.
    
    Tested on non-bootstrap builds on aarch64-linux-gnu (with
    -Wno-prio-ctor-dtor removed in order to get an error).
    
    libgcc/ChangeLog:
    
            PR libgcc/117600
            * Makefile.in (WERROR): New.
            * config/aarch64/t-aarch64: Handle WERROR.
            * configure: Regenerate.
            * configure.ac: Add support for --enable-werror.
    
    (cherry picked from commit fdc560aaaedfcf4e3a88379856badd7a153f41cf)

diff --git a/libgcc/config/aarch64/t-aarch64 b/libgcc/config/aarch64/t-aarch64
index d4c59227386..c7d83c71843 100644
--- a/libgcc/config/aarch64/t-aarch64
+++ b/libgcc/config/aarch64/t-aarch64
@@ -30,4 +30,4 @@ LIB2ADDEH += \
 	$(srcdir)/config/aarch64/__arm_za_disable.S
 
 SHLIB_MAPFILES += $(srcdir)/config/aarch64/libgcc-sme.ver
-LIBGCC2_CFLAGS += -Werror -Wno-prio-ctor-dtor
+LIBGCC2_CFLAGS += $(WERROR) -Wno-prio-ctor-dtor
diff --git a/libgcc/configure.ac b/libgcc/configure.ac
index 85e4f1bc48b..65cd3c6aa1a 100644
--- a/libgcc/configure.ac
+++ b/libgcc/configure.ac
@@ -733,6 +733,20 @@ AC_SUBST(md_unwind_header)
 AC_SUBST(sfp_machine_header)
 AC_SUBST(thread_header)
 
+AC_ARG_ENABLE(werror,
+[AS_HELP_STRING([--enable-werror],
+		[build with -Werror for selected targets])],
+[
+case ${enable_werror} in
+  no) WERROR="" ;;
+  *) WERROR="-Werror" ;;
+esac
+],
+[
+WERROR="-Werror"
+])
+AC_SUBST(WERROR)
+
 # We need multilib support.
 AC_CONFIG_FILES([Makefile])
 AC_CONFIG_COMMANDS([default],

